using System.Collections;
using System.Collections.Generic;
using System.Diagnostics.Tracing;
using UnityEngine;
using UnityEngine.SceneManagement;

public class Bootstrap : SingletonMono<Bootstrap>
{
    public UIManager uiManager;
    public EventCenter eventCenter;
    public ScenesManager scenesManager;

    protected override void Awake()
    {
        base.Awake();
        uiManager = new UIManager(this);
        eventCenter = new EventCenter();
        scenesManager = new ScenesManager(this);
        DontDestroyOnLoad(gameObject);
    }

    private void Start()
    {
        Debug.Log("<color=yellow>SʾUIHرUIEɫV</color>");
        uiManager.ShowPanel<UI_LoadingPanel>(E_UI_Layer.System, (panel) =>
        {
            ///1 Ϊٶ
            eventCenter.EventTrigger(Enum_EventType.UpdateProgress, 1f);
            scenesManager.LoadSceneAsyn("TestScene", () =>
            {
                Debug.Log("سɹ");
                eventCenter.EventTrigger(Enum_EventType.UpdateProgress, 5f);
            });

        });
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown("s"))
        {
            Debug.Log("Input.GetKeyDown(\"u\")");
            uiManager.ShowPanel<UI_TestPanel>( E_UI_Layer.Bot, (panel) =>
            {
                panel.OnInit();
                Debug.Log("UI_TestPanelʾɹ");
            });
        }
        if (Input.GetKeyDown("h"))
        {
            Debug.Log("Input.GetKeyDown(\"h\")");
            uiManager.HidePanel<UI_TestPanel>();
        }
        if (Input.GetKeyDown("e"))
        {
            Debug.Log("Input.GetKeyDown(\"e\")");
            eventCenter.EventTrigger(Enum_EventType.TestEvent1);
        }
    }


}
